"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var JSDocTag_1 = require("./JSDocTag");
/**
 * JS doc type tag node.
 */
var JSDocTypeTag = /** @class */ (function (_super) {
    tslib_1.__extends(JSDocTypeTag, _super);
    function JSDocTypeTag() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Gets the type expression node of the JS doc property type tag.
     */
    JSDocTypeTag.prototype.getTypeExpression = function () {
        // for some reason the compiler will still return a node when it doesn't exist
        var node = this.compilerNode.typeExpression;
        if (node != null && node.pos === node.end)
            return undefined;
        return this._getNodeFromCompilerNodeIfExists(this.compilerNode.typeExpression);
    };
    return JSDocTypeTag;
}(JSDocTag_1.JSDocTag));
exports.JSDocTypeTag = JSDocTypeTag;
