"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var manipulation_1 = require("../../../manipulation");
var base_1 = require("../base");
var callBaseSet_1 = require("../callBaseSet");
var TypeElement_1 = require("./TypeElement");
var callBaseGetStructure_1 = require("../callBaseGetStructure");
exports.MethodSignatureBase = base_1.ChildOrderableNode(base_1.JSDocableNode(base_1.QuestionTokenableNode(base_1.TypeParameteredNode(base_1.SignaturedDeclaration(base_1.PropertyNamedNode(TypeElement_1.TypeElement))))));
var MethodSignature = /** @class */ (function (_super) {
    tslib_1.__extends(MethodSignature, _super);
    function MethodSignature() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Removes this method signature.
     */
    MethodSignature.prototype.remove = function () {
        manipulation_1.removeInterfaceMember(this);
    };
    /**
     * Sets the node from a structure.
     * @param structure - Structure to set the node with.
     */
    MethodSignature.prototype.set = function (structure) {
        callBaseSet_1.callBaseSet(exports.MethodSignatureBase.prototype, this, structure);
        return this;
    };
    /**
     * Gets the structure equivalent to this node.
     */
    MethodSignature.prototype.getStructure = function () {
        return callBaseGetStructure_1.callBaseGetStructure(exports.MethodSignatureBase.prototype, this, {});
    };
    return MethodSignature;
}(exports.MethodSignatureBase));
exports.MethodSignature = MethodSignature;
