"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var TypeNode_1 = require("./TypeNode");
var IndexedAccessTypeNode = /** @class */ (function (_super) {
    tslib_1.__extends(IndexedAccessTypeNode, _super);
    function IndexedAccessTypeNode() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Gets the indexed access type node's object type node.
     *
     * This is `MyObjectType` in `MyObjectType["myIndex"]`.
     */
    IndexedAccessTypeNode.prototype.getObjectTypeNode = function () {
        return this._getNodeFromCompilerNode(this.compilerNode.objectType);
    };
    /**
     * Gets the indexed access type node's index type node.
     *
     * This is `"myIndex"` in `MyObjectType["myIndex"]`.
     */
    IndexedAccessTypeNode.prototype.getIndexTypeNode = function () {
        return this._getNodeFromCompilerNode(this.compilerNode.indexType);
    };
    return IndexedAccessTypeNode;
}(TypeNode_1.TypeNode));
exports.IndexedAccessTypeNode = IndexedAccessTypeNode;
