"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var TypeNode_1 = require("./TypeNode");
var ParenthesizedTypeNode = /** @class */ (function (_super) {
    tslib_1.__extends(ParenthesizedTypeNode, _super);
    function ParenthesizedTypeNode() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Gets the node within the parentheses.
     */
    ParenthesizedTypeNode.prototype.getTypeNode = function () {
        return this._getNodeFromCompilerNode(this.compilerNode.type);
    };
    /**
     * Sets the type within the parentheses.
     * @param textOrWriterFunction - Text or writer function to set the type with.
     */
    ParenthesizedTypeNode.prototype.setType = function (textOrWriterFunction) {
        this.getTypeNode().replaceWithText(textOrWriterFunction);
        return this;
    };
    return ParenthesizedTypeNode;
}(TypeNode_1.TypeNode));
exports.ParenthesizedTypeNode = ParenthesizedTypeNode;
