"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Output file of an emit.
 */
var OutputFile = /** @class */ (function () {
    /**
     * @private
     */
    function OutputFile(context, compilerObject) {
        this._compilerObject = compilerObject;
        this._context = context;
    }
    Object.defineProperty(OutputFile.prototype, "compilerObject", {
        /**
         * TypeScript compiler output file.
         */
        get: function () {
            return this._compilerObject;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Gets the file path.
     */
    OutputFile.prototype.getFilePath = function () {
        return this._context.fileSystemWrapper.getStandardizedAbsolutePath(this.compilerObject.name);
    };
    /**
     * Gets whether the byte order mark should be written.
     */
    OutputFile.prototype.getWriteByteOrderMark = function () {
        return this.compilerObject.writeByteOrderMark || false;
    };
    /**
     * Gets the file text.
     */
    OutputFile.prototype.getText = function () {
        return this.compilerObject.text;
    };
    return OutputFile;
}());
exports.OutputFile = OutputFile;
