"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var utils_1 = require("../../utils");
var FactoryStructurePrinter_1 = require("../FactoryStructurePrinter");
var ReturnTypedNodeStructurePrinter = /** @class */ (function (_super) {
    tslib_1.__extends(ReturnTypedNodeStructurePrinter, _super);
    function ReturnTypedNodeStructurePrinter(factory, alwaysWrite) {
        if (alwaysWrite === void 0) { alwaysWrite = false; }
        var _this = _super.call(this, factory) || this;
        _this.alwaysWrite = alwaysWrite;
        return _this;
    }
    ReturnTypedNodeStructurePrinter.prototype.printText = function (writer, structure) {
        var returnType = structure.returnType;
        if (returnType == null && this.alwaysWrite === false)
            return;
        returnType = returnType || "void";
        var returnTypeText = this.getTextWithQueuedChildIndentation(writer, returnType);
        if (!utils_1.StringUtils.isNullOrWhitespace(returnTypeText))
            writer.write(": " + returnTypeText);
    };
    return ReturnTypedNodeStructurePrinter;
}(FactoryStructurePrinter_1.FactoryStructurePrinter));
exports.ReturnTypedNodeStructurePrinter = ReturnTypedNodeStructurePrinter;
