"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var utils_1 = require("../../utils");
var FactoryStructurePrinter_1 = require("../FactoryStructurePrinter");
var formatting_1 = require("../formatting");
var TypeParameterDeclarationStructurePrinter = /** @class */ (function (_super) {
    tslib_1.__extends(TypeParameterDeclarationStructurePrinter, _super);
    function TypeParameterDeclarationStructurePrinter() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.multipleWriter = new formatting_1.CommaSeparatedStructuresPrinter(_this);
        return _this;
    }
    TypeParameterDeclarationStructurePrinter.prototype.printTextsWithBrackets = function (writer, structures) {
        if (structures == null || structures.length === 0)
            return;
        writer.write("<");
        this.printTexts(writer, structures);
        writer.write(">");
    };
    TypeParameterDeclarationStructurePrinter.prototype.printTexts = function (writer, structures) {
        this.multipleWriter.printText(writer, structures);
    };
    TypeParameterDeclarationStructurePrinter.prototype.printText = function (writer, structure) {
        if (typeof structure === "string") {
            writer.write(structure);
            return;
        }
        writer.write(structure.name);
        if (structure.constraint != null) {
            var constraintText = this.getTextWithQueuedChildIndentation(writer, structure.constraint);
            if (!utils_1.StringUtils.isNullOrWhitespace(constraintText))
                writer.write(" extends " + constraintText);
        }
        if (structure.default != null) {
            var defaultText = this.getTextWithQueuedChildIndentation(writer, structure.default);
            if (!utils_1.StringUtils.isNullOrWhitespace(defaultText))
                writer.write(" = " + defaultText);
        }
    };
    return TypeParameterDeclarationStructurePrinter;
}(FactoryStructurePrinter_1.FactoryStructurePrinter));
exports.TypeParameterDeclarationStructurePrinter = TypeParameterDeclarationStructurePrinter;
